#ifndef _REALTIME_THREAD
#define _REALTIME_THREAD

#include "classes.h"

#define GC_MEM									0
#define IMMORTAL_MEM							1

#define rt_get_thread(thread) ((Thread*)&(thread->_super))

FOURBYTES thread_start_time;

void init_rt_threads(void);
void init_rt_thread(RealtimeThread *rtThread, byte memoryType);

void dequeue_rt_thread(RealtimeThread *rtthread);
RealtimeThread* current_is_rt();

void prepare_2_wait(RealtimeThread *rtThread);
inline void schedule_periodic(RealtimeThread *rtthread);

void check_deadline();

inline void rt_set_start(RealtimeThread *rtThread, JINT);
inline void rt_set_period(RealtimeThread *rtThread, JINT);
inline void rt_set_cost(RealtimeThread *rtThread, int);
inline void rt_set_deadline(RealtimeThread *rtThread, int);

extern RealtimeThread* findRealtimeThread(Thread * t);

#endif
